
/* ============================================================================
   Markus Fulde                                                      13.02.2011
   ----------------------------------------------------------------------------

   Der Sourcecode fr das WorkFrame fr die Betty stammt aus dem Forum
                        http://www.bettyhacks.com
   und wurde speziell fr das Projekt StarLight angepasst. Dabei wurden
   teilweise nicht bentigte Funktionen aus Grnden der Speichergre und
   Laufzeitoptimierung (z.B. beim Download der Firmware) komplett entfernt.

   Der in dieser Version nun vorliegende Programmcode dient zur Kommunikation
   der Betty ber Funk mit dem Master-Modul des StarLight-Projekts.

   Aufgrund der groen nderungen und Ergnzungen am Code stelle ich die SW
   nicht erneut ber das Bettyhacks-Forum zur Verfgung.
   Ich erhebe keinen Anspruch des Copyrights auf jegliche SW-Teile dieses
   Projekts. Das Copyright und die Rechte am Code verbleiben in uneingeschrnker
   Forum unter Einhaltung der GNU General Public License bestehen.

   Mge jeder der den Code verwenden kann genauso viel Freude haben wie ich
   hatte!
   ============================================================================
   Historie:
   13.02.2011  Version 1  Erste vollstndige Version nach Optimierung und
                          Einbindung in Gesamtprojekt.
   ============================================================================
*/


/* =================================== Includes ============================ */

#include <stdio.h>
#include <stdarg.h>


/* ================== Datentypen und Variablendefinitionen ================= */

/*
char *gets(char *s)
{
char *r = s;
int c;

  while ((c = getchar()) != 0)
      *s++ = c;
      *s = 0;
      return r;
      }
*/

#ifndef MY
#define MY(x)   x
#else
#undef MY
#define MY(x)   My##x
#endif


/* ======================= Funktionen und Programmcode ===================== */

/*
   ----------------------------------------------------------------------------
   Funktion: MY
   ----------------------------------------------------------------------------
*/
char* MY(strcpy) (char *dst, const char *src)
{
   /* ----- lokale Variablen ----- */
   char *s = dst;


   /* ----- Programmcode ----- */
   while ((*dst++ = *src++) != '\0')
      continue;

   return s;
}
/* ----- Ende MY ----------------------------------------------------------- */


/*
   ----------------------------------------------------------------------------
   Funktion: _itoa
   ----------------------------------------------------------------------------
*/void _itoa(char *buf, unsigned int i, int base)
{
   /* ----- lokale Variablen ----- */
   char *s;
#define LEN   10
   int rem;
   static char rev[LEN+1];


   /* ----- Programmcode ----- */
   if (i == 0)
      s = "0";
   else
   {
      rev[LEN] = 0;
      s = &rev[LEN];
      while (i)
      {
         rem = i % base;
         if (rem < 10)
            *--s = rem + '0';
         else if (base == 16)
            *--s = "abcdef"[rem - 10];
         i /= base;
      }
   }
   MY(strcpy)(buf, s);
}
/* ----- Ende _itoa -------------------------------------------------------- */


/*
   ----------------------------------------------------------------------------
   Funktion: _print
   ----------------------------------------------------------------------------
*/int _print(char **ps, void (*_put)(char **, int), char *fmt, va_list va)
{
   /* ----- lokale Variablen ----- */
   char buf[10];
   char *bp;
   char *s;
   int i;
   int ret = 0;
   int prefix;
   int fill = ' ';
   int width = 0;


   /* ----- Programmcode ----- */
   while (*fmt)
   {
      bp = buf;

      if (*fmt != '%')
      {
         (*_put)(ps, *fmt);
         ret++;
      }
      else
      {
         if (fmt[1] == '#' && (fmt[2] == 'o' || fmt[2] == 'x'))
            ++fmt, prefix = 1;
         else
            prefix = 0;

         if (fmt[1] == '0')
         {
            fill = fmt[1];
            ++fmt;
         }

         if (fmt[1] >= '1' && fmt[1] <= '9')
         {
            width = fmt[1] - 0x31;
            ++fmt;
         }

         switch (*++fmt)
         {
         case 'd':
            i = va_arg(va, int);
            if (i < 0)
            {
               *bp++ = '-';
               i = -i;
            }
            _itoa(bp, i, 10);
            s = buf;
            goto print_string;
         case 'u':
         case 'o':
         case 'x':
            i = va_arg(va, unsigned int);
            if (*fmt == 'u')
               _itoa(bp, i, 10);
            else if (*fmt == 'o')
            {
               if (prefix)
                  *bp++ = '0';
               _itoa(bp, i, 8);
            }
            else
            {
               if (prefix)
               {
                  *bp++ = '0';
                  *bp++ = 'x';
               }

               if (width)
               {
                  width = (1 << (width << 2));
                  while (i < width && width > 1)
                  {
                     *bp++ = fill;
                     width >>= 4;
                  }
               }
               _itoa(bp, i, 16);
            }
            s = buf;
            goto print_string;
         case 'c':
            i = va_arg(va, int);
            (*_put)(ps, i);
            ret++;
            break;
         case 's':
            s = va_arg(va, char *);
            if (!s)
               s = "(null ptr passed)";
print_string:
            while (*s)
            {
               (*_put)(ps, *s++);
               ret++;
            }
            break;
         case 'f':
#ifdef FLOAT_PRINTF
            {
               int i;
               float f = va_arg(va, float);
               extern char *_fp_buf();

               s = _fp_buf(f);
               /* fp_to_string does not give format that C users are
               * used to. Convert.
               */
               if (s[1] == '.')
               {
                  if (s[0] == ' ')
                     s[0] = '0';
                  else if (s[0] == '-')
                  {
                     buf[0] = '-';
                     buf[1] = '0';
                     MY(strcpy)(&buf[2], &s[1]);
                     s = buf;
                  }
               }
               else if (s[0] == ' ')
                  s++;
               i = strlen(s);
               if (s[i-1] == '.')
               {
                  s[i] = '0';
                  s[i+1] = 0;
               }
            }
#else
            s = "<integer only print, use -lfp to relink>";
#endif
            goto print_string;

         }
      }
      fmt++;
      }
      return ret;
}
/* ----- Ende _print ------------------------------------------------------- */

/* =================================== Ende ================================ */

