/*
    timerfuncs.c - timer control functions
    Copyright (C) 2007  Ch. Klippel <ck@mamalala.net>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* ============================================================================
   Markus Fulde                                                      13.02.2011
   ----------------------------------------------------------------------------

   Der Sourcecode fr das WorkFrame fr die Betty stammt aus dem Forum
                        http://www.bettyhacks.com
   und wurde speziell fr das Projekt StarLight angepasst. Dabei wurden
   teilweise nicht bentigte Funktionen aus Grnden der Speichergre und
   Laufzeitoptimierung (z.B. beim Download der Firmware) komplett entfernt.

   Der in dieser Version nun vorliegende Programmcode dient zur Kommunikation
   der Betty ber Funk mit dem Master-Modul des StarLight-Projekts.

   Aufgrund der groen nderungen und Ergnzungen am Code stelle ich die SW
   nicht erneut ber das Bettyhacks-Forum zur Verfgung.
   Ich erhebe keinen Anspruch des Copyrights auf jegliche SW-Teile dieses
   Projekts. Das Copyright und die Rechte am Code verbleiben in uneingeschrnker
   Forum unter Einhaltung der GNU General Public License bestehen.

   Mge jeder der den Code verwenden kann genauso viel Freude haben wie ich
   hatte!
   ============================================================================
   Historie:
   13.02.2011  Version 1  Erste vollstndige Version nach Optimierung und
                          Einbindung in Gesamtprojekt.
   ============================================================================
*/

#ifndef TIMERFUNCS_H
#define TIMERFUNCS_H


/* =================================== Includes ============================ */

#include "timerirq.h"


/* ================== Datentypen und Variablendefinitionen ================= */

////////////////////////////////////////////////
///@Attention: Timer are using 5msec intervall!
////////////////////////////////////////////////
#define TIME_MSEC2TICKS(t)   (t/5)


volatile unsigned long T0overflow;


/* ======================== Prototyping ==================================== */


void startTimerIRQ (void);

/**
@brief Allocate a timer, set the time but do *NOT* start.

       Use @see startCB to start the timer

@Param  Timer expiry callback, time intervall

@return index of the allocated timer on success
        0xFF is no timer left
*/
unsigned int   addTimerCB (cb_fn cb, unsigned short intervall);
unsigned int   removeTimerCB (unsigned int cb);
void           startCB (unsigned int cb);
void           stopCB (unsigned int cb);
void           setCBIntervall (unsigned int cb, unsigned short intervall);
void           wait5ms (void);
void           waitus (unsigned long d);
unsigned char  addTimeout (volatile unsigned long* counter, unsigned long value);
unsigned char  removeTimeout (volatile unsigned long* counter);

#endif


/* =================================== Ende ================================ */

